﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CKPoolSet;
using CKRule;

namespace Salary
{
    public partial class FrmData : Form
    {
        DatabaseLgc _access = new DatabaseLgc();

        public FrmData()
        {
            InitializeComponent();
        }

        private void tsbSetExpr_Click(object sender, EventArgs e)
        {
            FrmRulePoolSet _f = new FrmRulePoolSet();
            _f.ShowDialog();
        }

        private void FrmData_Load(object sender, EventArgs e)
        {
            tsbQuery_Click(null, null);
        }

        private void tsbExit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private List<System.Reflection.PropertyInfo> _props = new List<System.Reflection.PropertyInfo>();

        private void tsbCalc_Click(object sender, EventArgs e)
        {
            if (dgvLst.SelectedRows.Count == 0) return;
            var _selRow = dgvLst.SelectedRows[0];
            if (_selRow == null) return;
            var _cond = _selRow.DataBoundItem as SalaryCond;
            _cond = new RuleFacade().Exec(FrmRulePoolSet.RuleInstName, _cond);
            if (_props.Count == 0)
            {
                _props = typeof(ResultCond).GetProperties().ToList();
            }
            var _strResult = "";
            int _index = 0;
            foreach (var _prop in _props)
            {
                if (_index > 0 && _index % 4 == 0)
                    _strResult += Environment.NewLine;
                _strResult += _prop.Name + " : " + _prop.GetValue(_cond.ResultCond, null) + "\t\t";
                _index++;
            }
            txtResult.Text = _strResult;
        }

        private void tsbQuery_Click(object sender, EventArgs e)
        {
            var _table = _access.GetTable("select * from 工资基本信息 order by id").ToList<SalaryCond>();
            dgvLst.DataSource = _table;
            dgvLst.AutoGenerateColumns = true;
            dgvLst.AllowUserToAddRows = false;
        }
    }
}
