﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CKRule;

namespace Salary
{
    /// <summary>
    /// 判断式规则编辑器
    /// </summary>
    partial class UcIfElseStyle : UserControl
    {
        /// <summary>
        /// 属性定义
        /// </summary>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public CustPoolCond PropDef { get; set; }

        /// <summary>
        /// 包
        /// </summary>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public PackageDef Package { get; set; }

        /// <summary>
        /// 如果文本框
        /// </summary>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public RichTextBox IfTextBox
        {
            get { return rtbIf; }
        }

        /// <summary>
        /// 那么文本框
        /// </summary>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public RichTextBox ThenTextBox
        {
            get { return rtbThen; }
        }

        /// <summary>
        /// 否则文本框
        /// </summary>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public RichTextBox ElseTextBox
        {
            get { return rtbElse; }
        }

        /// <summary>
        /// 当前的编辑框
        /// </summary>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public RichTextBox CurTextBox
        {
            get
            {
                if (ckbIf.Checked)
                {
                    return rtbIf;
                }
                else if (ckbThen.Checked)
                {
                    return rtbThen;
                }
                else if (ckbElse.Checked)
                {
                    return rtbElse;
                }
                return rtbIf;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public UcIfElseStyle()
        {
            InitializeComponent();
        }

        private void UcIfElseStyle_Load(object sender, EventArgs e)
        {
            LoadData();
        }

        /// <summary>
        /// 加载数据
        /// </summary>
        public void LoadData()
        {
            if (PropDef == null) return;
            rtbIf.Text = PropDef.CondCode;
            //rtbIf.IsScript = PropDef.IfCodeIsScript;
            rtbThen.Text = PropDef.InitCode;
            //rtbThen.IsScript = PropDef.ThenCodeIsScript;
            rtbElse.Text = PropDef.CalcCode;
            //rtbElse.IsScript = PropDef.ElseCodeIsScript;
        }

        private void UcIfElseStyle_SizeChanged(object sender, EventArgs e)
        {
            pnlElse.Height = (this.Height - pnlIf.Height) / 2;
        }

        /// <summary>
        /// 提交属性
        /// </summary>
        /// <returns></returns>
        public bool Sumbit()
        {
            if (string.IsNullOrEmpty(rtbIf.Text))
            {
                MessageBox.Show("如果不能为空");
                return false;
            }
            if (string.IsNullOrEmpty(rtbThen.Text) && string.IsNullOrEmpty(rtbElse.Text))
            {
                MessageBox.Show("那么和否则不能同时为空");
                return false;
            }
            PropDef.CondCode = rtbIf.Text;
            //PropDef.IfCodeIsScript = rtbIf.IsScript;
            PropDef.InitCode = rtbThen.Text;
            //PropDef.ThenCodeIsScript = rtbThen.IsScript;
            PropDef.CalcCode = rtbElse.Text;
            //PropDef.ElseCodeIsScript = rtbElse.IsScript;
            //PropDef.CodeStyle = CodeStyleDef.IfElseStyle;
            return true;
        }


        /// <summary>
        /// 将内容设置到当前编辑框
        /// </summary>
        /// <param name="content"></param>
        /// <param name="isScript"></param>
        public void SetCurEdit(string content, bool isScript)
        {
            if (ckbIf.Checked)
            {
                rtbIf.Text = content;
                //rtbIf.IsScript = isScript;
                //PropDef.IfCodeIsScript = isScript;
            }
            else if (ckbThen.Checked)
            {
                rtbThen.Text = content;
                //rtbThen.IsScript = isScript;
                //PropDef.ThenCodeIsScript = isScript;
            }
            else if (ckbElse.Checked)
            {
                rtbElse.Text = content;
                //rtbElse.IsScript = isScript;
                //PropDef.ElseCodeIsScript = isScript;
            }
        }

        /// <summary>
        /// 清空
        /// </summary>
        public void Clear()
        {
            rtbIf.Text = "";
            rtbThen.Text = "";
            rtbElse.Text = "";
        }

        private void ckb_CheckedChanged(object sender, EventArgs e)
        {
            var curCkb = sender as CheckBox;
            if (curCkb == null) return;
            if (curCkb.Checked)
            {
                if (curCkb != ckbIf)
                    ckbIf.Checked = false;
                if (curCkb != ckbThen)
                    ckbThen.Checked = false;
                if (curCkb != ckbElse)
                    ckbElse.Checked = false;
            }
        }

        private void rtbIf_Click(object sender, EventArgs e)
        {
            ckbIf.Checked = true;
        }

        private void rtbThen_Click(object sender, EventArgs e)
        {
            ckbThen.Checked = true;
        }

        private void rtbElse_Click(object sender, EventArgs e)
        {
            ckbElse.Checked = true;
        }
    }
}
